﻿-- Author      : RisM
-- Create Date : 9/21/2009 3:07:03 AM

local SpeakinSpell = LibStub("AceAddon-3.0"):GetAddon("SpeakinSpell")
local L = LibStub("AceLocale-3.0"):GetLocale("SpeakinSpell", false)

SpeakinSpell:PrintLoading("gui/currentmessages.lua")

-------------------------------------------------------------------------------
-- GUI LAYOUT - Message Settings
-------------------------------------------------------------------------------


SpeakinSpell.OptionsGUI.args.CurrentMessagesGUI = {
	order = 2,
	type = "group",
	name = L["General Settings"],
	desc = L["General Settings TOOLTIP"],
	args = {
		---------------------------------------------------------------
		Caption = {
			name = L["Edit Speech / Announcement Settings"],
			type = "header",
			order = 1,
		},
		SearchOptions = {
			--name = L["1. Search..."],
			name = function()
				SpeakinSpell:SetLastPageViewed( "CurrentMessagesGUI", L["Message Settings TITLE"] )
				return SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["1. Search..."]
			end,
			order = 2,
			type = "group",
			guiInline = true,
			args = {
				EventTextFilterSelect = {
					order = 2,
					type = "input",
					width = "full",
					name = L["Search"],
					desc = L["Type some of the name of what you're looking for, to narrow down the list below"],
					get = function() return  SpeakinSpell:CurrentMessagesGUI_OnGetSetEventTextFilter("GET",nil) end,
					set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnGetSetEventTextFilter("SET",value) end,
				},
				EventTypeFilterSelect = {
					order = 3,
					type = "select",
					width = "full",
					name = L["Select a Category of Events"],
					desc = L["Select a Category of Events TOOLTIP"],
					values = L.EVENTTYPES.AS_FILTERS,
					get = function() return  SpeakinSpell:CurrentMessagesGUI_OnEventTypeFilterSelect("GET",nil) end,
					set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnEventTypeFilterSelect("SET",value) end,
				},
				ShowMoreThanAHundred = {
					order = 4,
					type = "toggle",
					width = "full",
					name = L["Show More than 100 Search Results"],
					desc = L["Enable to show more than 100 search results in the drop-down list below.\n\nEnabling this option can slow down the performance of this window."],
					get = function() return  SpeakinSpell:CurrentMessagesGUI_OnToggleShowMoreThanAHundred("GET",nil) end,
					set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnToggleShowMoreThanAHundred("SET",value) end,
				},
			},
		},
--		Gap1 = {
--			name = "\n",
--			order = 3,
--			type = "description",
--			width = "full",
--		},
		---------------------------------------------------------------
		SelectGroup = {
			name = SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["2. Select..."],
			order = 4,
			type = "group",
			guiInline = true,
			args = {
				NoSearchResults = {
					name = "\n"..L["No Matching Search Results Found"].."\n",
					order = 11,
					type = "description",
					width = "full",
					hidden = function() return SpeakinSpell:CurrentMessagesGUI_ShowSelectedEventControls() end,
				},
				EventSelect = {
					order = 12,
					type = "select",
					width = "full",
					--name = L["Select a Spell"],
					name = function() return SpeakinSpell:GUI_GetEventSelectLabel() end,
					desc = L["Select a Spell TOOLTIP"],
					values = {},
					get = function() return  SpeakinSpell:CurrentMessagesGUI_OnEventSelect("GET",nil) end,
					set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnEventSelect("SET",value) end,
					hidden = function() return not SpeakinSpell:CurrentMessagesGUI_ShowSelectedEventControls() end,
				},
				CreateSpellButton = {
					order = 13,
					type = "execute",
					name = L["Create New..."],
					desc = L["Create New... TOOLTIP"],
					func = function() SpeakinSpell:CurrentMessagesGUI_OnClickGotoCreate() end,
				},
			},
		},
--		Gap2 = {
--			name = "\n",
--			order = 5,
--			type = "description",
--			width = "full",
--		},
		---------------------------------------------------------------
		EditGroup = {
			name = SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["3. Edit..."],
			order = 6,
			type = "group",
			guiInline = true,
			hidden = function() return not SpeakinSpell:CurrentMessagesGUI_ShowSelectedEventControls() end,
			args = {
				Caption = {
					order = 1,
					type = "header",
					name = function()
						return SpeakinSpell:CurrentMessagesGUI_GetSelectedDisplayNameForEditLabel()
					end
				},
				------------------------------
				FrequencyOptionsGroup = {
					order = 2,
					type = "group",
					name = L["Chat Frequency / Spam Reduction Options"],
					--name = L["Limits"],
					--desc = L["Edit Chat Announcement Frequency and Spam Reduction Options"],
					guiInline = true,
					args = {
--						Header = {
--							order = 1,
--							name = L["Limits"],
--							type = "header",
--						},
						Minimize = {
							order = 4,
							width = "full",
							type = "toggle",
							func = function()
								SpeakinSpellSavedDataForAll.ShowFrequencyGroup = not SpeakinSpellSavedDataForAll.ShowFrequencyGroup
							end,
							get = function() return SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
							set = function(_,value) SpeakinSpellSavedDataForAll.ShowFrequencyGroup = value end,
							name = L["Show These Options"],
							desc = L["Show these options for chat frequency, cooldowns, and other limits"]
						}, --"show/hide"
--						Caption = {
--							order = 3,
--							name = L["Edit Chat Announcement Frequency and Spam Reduction Options"].."\n",
--							type = "header",
--							--hidden = function() return not SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
--						}, --L["Edit Chat Announcement Frequency and Spam Reduction Options"]
						DeleteSpellButton = {
							order = 2,
							type = "execute",
							name = L["Delete this Event"],
							desc = L["Delete Spell TOOLTIP"],
							func = function() SpeakinSpell:CurrentMessagesGUI_OnClickDelete() end,
							--hidden = function() return not SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
						}, --L["Delete this Event"]
						Disable = {
							order = 1,
							type = "toggle",
							width = "full",
							name = L["Disable announcements for this Speech Event"],
							desc = L["Disable announcements for this spell TOOLTIP"],
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnSpellDisable("GET",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnSpellDisable("SET",value) end,
							--hidden = function() return not SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
						}, --"disable this event"
						FrequencySelect = {
							order = 31,
							type = "range",
							width = "full",
							name = L["How often do you want to announce this spell?"],
							desc = L["How often TOOLTIP"],
							min = 0.01, max = 1.00, step=0.01,
							isPercent = true,
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnFrequencySelect("GET",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnFrequencySelect("SET",value) end,
							hidden = function() return not SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
						}, --"random chance"
						CooldownSlider = {
							order = 32,
							type = "range",
							width = "full",
							name = L["Cooldown on announcements for this spell"] ,
							desc = L["Cooldown TOOLTIP"],
							min =0, max = 600, step=1, -- allowing for 0 seconds up to 10 minutes
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnCooldownSlider("GET",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnCooldownSlider("SET",value) end,
							hidden = function() return not SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
						}, --"cooldown (seconds)"
						OncePerCombatToggle = {
							order = 33,
							type = "toggle",
							width = "double",
							name = L["Limit once per combat"],
							desc = L["Limit once per combat TOOLTIP"],
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnOncePerCombatToggle("GET",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnOncePerCombatToggle("SET",value) end,
							hidden = function() return not SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
						},
						OncePerTargetToggle = {
							order = 34,
							type = "toggle",
							width = "double",
							name = L["Limit once per target"],
							desc = L["Limit once per target TOOLTIP"],
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnOncePerTargetToggle("GET",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnOncePerTargetToggle("SET",value) end,
							hidden = function() return not SpeakinSpellSavedDataForAll.ShowFrequencyGroup end,
						},
					}, -- end FrequencyOptionsGroup.args
				}, -- end FrequencyOptionsGroup
--				Gap1 = {
--					name = "\n",
--					order = 22,
--					type = "description",
--					width = "full",
--				},
				------------------------------
				ChatChannelOptionsGroup = {
					order = 22,
					type = "group",
					name = L["Chat Channels / Whisper Options"],
					--name = L["Channels/Whisper"],
					--desc = L["Edit Chat Channel and Whisper Options"],
					guiInline = true,
					args = {
--						Header = {
--							order = 1,
--							name = L["Channels/Whisper"],
--							type = "header",
--						},
						Minimize = {
							order = 1,
							width = "full",
							type = "toggle",
							func = function()
								SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup = not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup
							end,
							get = function() return SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							set = function(_,value) SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup = value end,
							name = L["Show These Options"],
							desc = L["Show these options for chat channel selections"]
						}, --"show/hide"
--						Caption = {
--							order = 2,
--							name = L["Edit Chat Channel and Whisper Options"].."\n",
--							type = "description",
--						},
						WhisperTargetToggle = {
							order = 3,
							type = "toggle",
							width = "full",
							name = L["Whisper the message to your target"],
							desc = L["Whisper the message to your target TOOLTIP"],
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnWhisperTarget("GET",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnWhisperTarget("SET",value) end,
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
						},
						ChannelSelectCaption = {
							order = 10,
							type = "description",
							width= "full",
							name = "\n"..L["Select the channels to use when announcing this spell when"],
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
						},
						ChannelSelectSolo = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 11,
							type = "select",
							name = L["By yourself"],
							desc = L["By yourself TOOLTIP"],
							values = { -- color-coded to match default chat channel colors
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								--[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								--[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								--[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","Solo",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","Solo",value) end,
						},
						ChannelSelectParty = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 12,
							type = "select",
							name = L["In a Party"],
							desc = L["In a Party TOOLTIP"],
							values = { -- color-coded to match default chat channel colors
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								--[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","Party",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","Party",value) end,
						},
						ChannelSelectRaid = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 13,
							type = "select",
							name = L["In a Raid"],
							desc = L["In a Raid TOOLTIP"],
							values = { -- color-coded to match default chat channel colors
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","Raid",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","Raid",value) end,
						},
						ChannelSelectPartyLeader = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 14,
							type = "select",
							name = L["Party Leader"],
							desc = L["Use this channel if you are the leader of a 5-man party"],
							values = { -- color-coded to match default chat channel colors
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","PartyLeader",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","PartyLeader",value) end,
						},
						ChannelSelectRaidLeader = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 15,
							type = "select",
							name = L["Raid Leader"],
							desc = L["Use this channel if you are the leader of a raid group"],
							values = { -- color-coded to match default chat channel colors
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","RaidLeader",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","RaidLeader",value) end,
						},
						ChannelSelectRaidOfficer = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 16,
							type = "select",
							name = L["Raid Officer"],
							desc = L["Use this channel if you are promoted to assist in a raid group"],
							values = { -- color-coded to match default chat channel colors
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","RaidOfficer",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","RaidOfficer",value) end,
						},
						ChannelSelectBG = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 17,
							type = "select",
							name = L["In a Battleground"],
							desc = L["In a Battleground TOOLTIP"],
							values = { -- color-coded to match default chat channel colors
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								--[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								--[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								--[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","BG",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","BG",value) end,
						},
						ChannelSelectArena = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 18,
							type = "select",
							name = L["In Arena"],
							desc = L["In Arena TOOLTIP"],
							values = { -- color-coded to match default chat channel colors
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","Arena",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","Arena",value) end,
						},
						ChannelSelectWG = {
							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowChannelsGroup end,
							order = 19,
							type = "select",
							name = L["In Wintergrasp"],
							desc = L["In Wintergrasp TOOLTIP"],
							values = { -- color-coded to match default chat channel colors
								[L["SPEAKINSPELL CHANNEL"]]	= SpeakinSpell.Colors.Channels.SPEAKINSPELL..L["SPEAKINSPELL CHANNEL"],
								[L["SELF RAID WARNING CHANNEL"]]	= SpeakinSpell.Colors.Channels.SELFRAIDWARN..L["SELF RAID WARNING CHANNEL"],
								[L["GUILD"]]		= SpeakinSpell.Colors.Channels.GUILD..L["GUILD"],
								--[L["BATTLEGROUND"]]	= SpeakinSpell.Colors.Channels.BATTLEGROUND..L["BATTLEGROUND"],
								[L["RAID"]]			= SpeakinSpell.Colors.Channels.RAID..L["RAID"],
								[L["PARTY"]]		= SpeakinSpell.Colors.Channels.PARTY..L["PARTY"],
								[L["SAY"]]			=               L["SAY"],
								[L["EMOTE"]]		= SpeakinSpell.Colors.Channels.EMOTE..L["EMOTE"],
								[L["YELL"]]			= SpeakinSpell.Colors.Channels.YELL..L["YELL"],
								--[L["RAID_WARNING"]]	= SpeakinSpell.Colors.Channels.RAID_WARNING..L["RAID_WARNING"],
								[L["Silent"]]		=               L["Silent"], --tried light gray to indicate disabled, but it made the control appear to be disabled, so use the default color (white)
							},
							get = function() return  SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("GET","WG",nil) end,
							set = function(_, value) SpeakinSpell:CurrentMessagesGUI_OnChannelSelect("SET","WG",value) end,
						},
					}, -- end args
				}, -- end ChatChannelOptionsGroup
--				Gap2 = {
--					name = "\n",
--					order = 23,
--					type = "description",
--					width = "full",
--				},
				------------------------------
				SpeechListGroup = {
					order = 24,
					type = "group",
					name = L["Speeches"],
--					name = function()
--						return L["Speeches for "]..SpeakinSpell:CurrentMessagesGUI_GetSelectedDisplayNameForEditLabel()
--					end,
					--desc = L["Edit the random speeches used for this Speech Event announcement"],
					guiInline = true,
					args = {
--						Header = {
--							order = 1,
--							name = L["Speeches"],
--							type = "header",
--						},
--						Minimize = {
--							order = 1,
--							width = "full",
--							type = "toggle",
--							get = function() return SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowSpeechesGroup end,
--							set = function(_,value) SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowSpeechesGroup = value end,
--							name = L["Show the Speech List"],
--							desc = L["Show the list of speeches, for editing what you say to announce this event"]
--						}, --"show/hide"
--						Caption = {
--							hidden = function() return not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowSpeechesGroup end,
--							order = 3,
--							type = "header",
--							name = L["Edit the random speeches used for this Speech Event announcement"].."\n",
--						}, --L["Edit the random speeches used for this Speech Event announcement"]
						Delete = {
							order = 2,
							type = "execute",
							name = L["Delete All Speeches"],
							desc = L["Delete all of the speeches for the selected event, INCLUDING read-only speeches"],
							func = function() SpeakinSpell:CurrentMessageGUI_DeleteAllSpeeches() end,
							hidden = function()
								--if not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowSpeechesGroup then
								--	return true
								--end
								local EventTableEntry = SpeakinSpell:CurrentMessagesGUI_GetSelectedEventObject()
								if (not EventTableEntry) then
									return true
								end
								return SpeakinSpell:IsTableEmpty(EventTableEntry.Messages)
							end,
						}, --L["Delete All Speeches"]
						ShowReadyOnly = {
							order = 4,
							type = "toggle",
							width = "full",
							name = L["Show Read-Only Speeches"],
							desc = L["Toggle showing read-only speeches in the list below."],
							get = function() return SpeakinSpellSavedDataForAll.ShowReadOnlySpeeches end,
							set = function(_,value) SpeakinSpellSavedDataForAll.ShowReadOnlySpeeches = value end,
						}, --L["Show Ready-Only Speeches"]
						NumHidden = {
							order = 5,
							type = "description",
							hidden = function()
								return SpeakinSpellSavedDataForAll.ShowReadOnlySpeeches
							end,
							name = function()
								local EventTableEntry = SpeakinSpell:CurrentMessagesGUI_GetSelectedEventObject()
								if not EventTableEntry then
									return ""
								end
								local hidden = 0
								for s,b in pairs(EventTableEntry.ReadOnly) do
									hidden = hidden+1
								end
								local total = #(EventTableEntry.Messages)
								return string.format( L["%d of %d speeches are read-only / hidden"], hidden, total )
							end,
						},
						-- CreateGUI_CurrentMessagesGUI will add speech boxes here
					},
				},
			}, --end args
		}, --end EditGroup
	}, --end args
} --end CurrentMessagesGUI



-- create message boxes
function SpeakinSpell:CreateGUI_CurrentMessagesGUI()
	-- add SpeakinSpell.MAX.MESSAGES_PER_SPELL random speech input boxes
	local args = self.OptionsGUI.args.CurrentMessagesGUI.args.EditGroup.args.SpeechListGroup.args
	for i=1,SpeakinSpell.MAX.MESSAGES_PER_SPELL,1 do
		args["SpellMessage"..i] = {
			order = i + 100,
			width = "full",
			type = "group",
			name = string.format(L["Random Speech i"], i), -- "Random Speech %d"
			hidden = function() return not self:CurrentMessagesGUI_ShowSpeechBox(i) end,
			args = {
				Edit = {
					hidden = function() return self:CurrentMessagesGUI_IsReadOnlySpeech(i) end,
					order = 1,
					type = "input",
					multiline = true,
					width = "full",
					--name = string.format(L["Random Speech i"], i), -- "Random Speech %d"
					name = L["Edit"],
					desc = L["Random Speech i TOOLTIP"],
					get = function() return  self:CurrentMessagesGUI_OnMessage("GET",i,nil) end,
					set = function(_, value) self:CurrentMessagesGUI_OnMessage("SET",i, value) end,
				}, --L["Random Speech i"] text box
				Delete = {
					order = 2,
					type = "execute",
					name = L["Delete"],
					desc = L["Delete this speech"],
					func = function() self:CurrentMessagesGUI_OnDeleteSpeech(i) end,
					hidden = function() return not self:CurrentMessagesGUI_ShowDeleteSpeech(i) end,
				}, --L["Delete this speech"]
				ReadOnly = {
					order = 4,
					type = "toggle",
					name = L["Read-Only"],
					desc = L["Toggle showing edit controls or a compressed display"],
					get = function(_,ReadOnly) return self:CurrentMessagesGUI_IsReadOnlySpeech(i,ReadOnly) end,
					set = function(_,ReadOnly) self:CurrentMessagesGUI_ToggleReadOnly(i,ReadOnly) end,
					hidden = function() return not self:CurrentMessagesGUI_ShowReadyOnlySpeech(i) end,
				},
				Text = {
					order = 3,
					type = "description",
					width = "full",
					name = function() return self:CurrentMessagesGUI_OnMessage("GET",i,nil) end,
					hidden = function() return not self:CurrentMessagesGUI_IsReadOnlySpeech(i) end,
				},
			},
		}
	end
end



-------------------------------------------------------------------------------
-- OPTIONS GUI FUNCTIONS - MESSAGE SETTINGS
-------------------------------------------------------------------------------


function SpeakinSpell:CurrentMessagesGUI_IsReadOnlySpeech( index )
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		return
	end
	
	local msg = EventTableEntry.Messages[index]
	if not msg then
		return
	end
	
	return EventTableEntry.ReadOnly[ msg ]
end

function SpeakinSpell:CurrentMessagesGUI_ToggleReadOnly( index, ReadOnly )
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		return
	end
	
	local msg = EventTableEntry.Messages[index]
	if not msg then
		return
	end
	
	if ReadOnly then
		EventTableEntry.ReadOnly[ msg ] = true
	else
		EventTableEntry.ReadOnly[ msg ] = nil
	end
end


function SpeakinSpell:CurrentMessageGUI_DeleteAllSpeeches()
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		return
	end
	EventTableEntry.Messages = {}
	EventTableEntry.ReadOnly = {}
end


function SpeakinSpell:CurrentMessagesGUI_GetSelectedEventObject()
	local eventkey = self.RuntimeData.OptionsGUIStates.MessageSettings.SelectedEventKey
	if eventkey then
		return SpeakinSpellSavedData.EventTable[eventkey]
	else
		return nil
	end
end


function SpeakinSpell:CurrentMessagesGUI_ValidateSelectedEvent()
	-- get the selected EventTableEntry
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if EventTableEntry then
		if self:MatchesFilter(EventTableEntry.DetectedEvent,true) then
			-- the current selection is valid, so keep it
			return
		end
		--else, the current selection did not match the filter, so select a default
	end
	
	-- select the first thing in the list, if possible
	for key,EventTableEntry in pairs(SpeakinSpellSavedData.EventTable) do
		if self:MatchesFilter(EventTableEntry.DetectedEvent,true) then
			-- the current selection is valid, so keep it
			self.RuntimeData.OptionsGUIStates.MessageSettings.SelectedEventKey = key
			return
		end
	end
	
	-- our spell list is empty or nothing matches the filter
	self.RuntimeData.OptionsGUIStates.MessageSettings.SelectedEventKey = nil
end



function SpeakinSpell:CurrentMessagesGUI_OnClickDelete()
	local funcname = "CurrentMessagesGUI_OnClickDelete"

	-- get the selected EventTableEntry
	local eventkey = self.RuntimeData.OptionsGUIStates.MessageSettings.SelectedEventKey
	if not eventkey then
		self:ErrorMsg(funcname, "no event selected")
		return
	end
	
	-- update GUI state
	self.OptionsGUI.args.CurrentMessagesGUI.args.SelectGroup.args.EventSelect.values[eventkey] = nil
	self.RuntimeData.OptionsGUIStates.MessageSettings.SelectedEventKey = nil
	
	-- delete the current selection from the SavedData table
	self:DeleteSpell(eventkey)
end



function SpeakinSpell:CurrentMessagesGUI_OnToggleShowMoreThanAHundred(getset,value)
	if "GET" == getset then
		-- rebuild the list to match the new filter if its out of date
		self:CurrentMessagesGUI_RebuildSpellList()
		return SpeakinSpellSavedData.ShowMoreThanAHundred
	else -- "SET"
		-- if the filter is changing, then rebuild the spell/event list
		self:SetFilterShowMoreThanAHundred(value)
		-- rebuild the list to match the new filter
		self:CurrentMessagesGUI_RebuildSpellList()
	end
end


function SpeakinSpell:CurrentMessagesGUI_OnClickGotoCreate()
	InterfaceOptionsFrame_OpenToCategory(L["Create New..."])
end


function SpeakinSpell:CurrentMessagesGUI_OnEventTypeFilterSelect(getset, value)
	if "GET" == getset then
		-- rebuild the list to match the new filter if its out of date
		self:CurrentMessagesGUI_RebuildSpellList()
		return SpeakinSpell.RuntimeData.OptionsGUIStates.SelectedEventTypeFilter
	else -- "SET"
		-- if the filter is changing, then rebuild the spell/event list
		self:SetFilter(value,nil)
		-- rebuild the list to match the new filter
		self:CurrentMessagesGUI_RebuildSpellList()
	end
	-- NOTE: the current selection will be repaired to match the new filter in _ValidateSelectedEvent
	--		as a side effect when the GUI framework automatically tries to get the new value of 
	--		the rest of the controls on the page, including the selected event
end


function SpeakinSpell:CurrentMessagesGUI_OnGetSetEventTextFilter(getset, value)
	if "GET" == getset then
		-- rebuild the list to match the new filter if its out of date
		self:CurrentMessagesGUI_RebuildSpellList()
		return SpeakinSpell.RuntimeData.OptionsGUIStates.SelectedEventTextFilter
	else -- "SET"
		-- if the filter is changing, then rebuild the spell/event list
		self:SetFilter(nil,value)
		-- rebuild the list to match the new filter
		self:CurrentMessagesGUI_RebuildSpellList()
	end
	-- NOTE: the current selection will be repaired to match the new filter in _ValidateSelectedEvent
	--		as a side effect when the GUI framework automatically tries to get the new value of 
	--		the rest of the controls on the page, including the selected event
end

function SpeakinSpell:CurrentMessagesGUI_OnEventSelect(getset, value)
	if "GET" == getset then
		-- create a side-effect to update the shown/hidden state of all options GUI controls
		self:CurrentMessagesGUI_RebuildSpellList()
		-- return the current spell selection
		return self.RuntimeData.OptionsGUIStates.MessageSettings.SelectedEventKey
	else -- "SET"
		-- update the current selection
		self.RuntimeData.OptionsGUIStates.MessageSettings.SelectedEventKey = value
	end
end


function SpeakinSpell:CurrentMessagesGUI_OnChannelSelect(getset, scenario, value)
	local funcname = "CurrentMessagesGUI_OnChannelSelect"
		
	-- get the selected EventTableEntry
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg(funcname, "no event selected")
		return
	end

	if "GET" == getset then
		--self:DebugMsg(funcname,"GET "..scenario..":"..tostring(EventTableEntry.Channels[scenario]))
		if EventTableEntry.Channels[scenario] then
			return L[EventTableEntry.Channels[scenario]]
		else
			return L["Silent"]
		end
	else --"SET"
		-- store the new channel selection
		if value == L["Silent"] then
			EventTableEntry.Channels[scenario] = nil
		else
			-- create a reverse lookup table to un-localize channel names
			-- so we can return a channel name that is compatible with SendChatMessage()
			local CHANNEL_TABLE = {
				[L["SAY"]]			= "SAY",
				[L["PARTY"]]		= "PARTY",
				[L["RAID"]]			= "RAID",
				[L["EMOTE"]]		= "EMOTE",
				[L["BATTLEGROUND"]]	= "BATTLEGROUND",
				[L["YELL"]]			= "YELL",
				[L["RAID_WARNING"]]	= "RAID_WARNING",
				[L["GUILD"]]		= "GUILD",
				[L["SPEAKINSPELL CHANNEL"]] = "SPEAKINSPELL CHANNEL",
				[L["SELF RAID WARNING CHANNEL"]] = "SELF RAID WARNING CHANNEL",
			}
			EventTableEntry.Channels[scenario] = CHANNEL_TABLE[value]
		end
		--self:DebugMsg(funcname,"set "..scenario..":"..tostring(EventTableEntry.Channels[scenario]))
	end
end



function SpeakinSpell:CurrentMessagesGUI_OnWhisperTarget(getset, value)
	-- make sure we have a valid spell selection
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg( "CurrentMessagesGUI_OnWhisperTarget", "no event selected" )
		return false
	end
	
	if "GET" == getset then
		return EventTableEntry.WhisperTarget
	else
		EventTableEntry.WhisperTarget = value
	end
end


function SpeakinSpell:CurrentMessagesGUI_OnMessage(getset, index, value)
	local funcname = "CurrentMessagesGUI_OnMessage"
	
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg("CurrentMessagesGUI_OnMessage", "no event selected")
		return ""
	end
	
	if "GET" == getset then
		local msg = EventTableEntry.Messages[index]
		if not msg then
			msg = ""
		end
		return msg
	else -- "SET"
		-- make sure we have a message table for the currently selected spell
		if not EventTableEntry.Messages then
			EventTableEntry.Messages = {}
		end
		
		EventTableEntry.Messages[ index ] = value

		-- remove holes and duplicates from the message table
		EventTableEntry.Messages = self:StringArray_Compress( EventTableEntry.Messages )
		
		return EventTableEntry.Messages[index] -- only returning something for symmetry
	end
end



function SpeakinSpell:CurrentMessagesGUI_OnDeleteSpeech(index)
	local funcname = "CurrentMessagesGUI_OnDeleteSpeech"
	
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg(funcname, "no event selected")
		return
	end
	
	local Messages = EventTableEntry.Messages -- create reference for shortcut notation
	
	-- delete the item
	Messages[index] = nil
	
	-- fill holes in the array
	EventTableEntry.Messages = self:StringArray_Compress( Messages )
end

function SpeakinSpell:CurrentMessagesGUI_ShowDeleteSpeech(index)
	local funcname = "CurrentMessagesGUI_ShowDeleteSpeech"
	
	if self:CurrentMessagesGUI_IsReadOnlySpeech(index) then
		return false
	end
	
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		return false
	end

	local msg = EventTableEntry.Messages[index]
	return ( (msg ~= nil) and (msg ~= "") )
end


function SpeakinSpell:CurrentMessagesGUI_ShowReadyOnlySpeech( index )
	local funcname = "CurrentMessagesGUI_ShowReadyOnlySpeech"
	
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		return false
	end

	local msg = EventTableEntry.Messages[index]
	return ( (msg ~= nil) and (msg ~= "") )
end


function SpeakinSpell:CurrentMessagesGUI_OnSpellDisable(getset, value)
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg("CurrentMessagesGUI_OnSpellDisable", "no event selected")
		return
	end

	if "GET" == getset then
		return EventTableEntry.DisableAnnouncements
	else -- "SET"
		EventTableEntry.DisableAnnouncements = value
	end
end


function SpeakinSpell:CurrentMessagesGUI_OnFrequencySelect(getset, value)
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg("CurrentMessagesGUI_OnFrequencySelect", "no event selected")
		return
	end
	
	if "GET" == getset then	
		return EventTableEntry.Frequency
	else --"SET"
		EventTableEntry.Frequency = value
	end
end


function SpeakinSpell:CurrentMessagesGUI_OnCooldownSlider(getset, value)
	local funcname = "CurrentMessagesGUI_OnCooldownSlider"

	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg(funcname, "no event selected")
		return
	end
	
	if "GET" == getset then	
		return EventTableEntry.Cooldown
	else --"SET"
		EventTableEntry.Cooldown = value
	end
end


function SpeakinSpell:CurrentMessagesGUI_OnOncePerCombatToggle(getset, value)
	local funcname = "CurrentMessagesGUI_OnOncePerCombatToggle"

	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg(funcname, "no event selected")
		return
	end
	
	if "GET" == getset then	
		return EventTableEntry.OncePerCombat
	else --"SET"
		EventTableEntry.OncePerCombat = value
	end
end


function SpeakinSpell:CurrentMessagesGUI_OnOncePerTargetToggle(getset, value)
	local funcname = "CurrentMessagesGUI_OnOncePerTargetToggle"

	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		self:ErrorMsg(funcname, "no event selected")
		return
	end
	
	if "GET" == getset then	
		return EventTableEntry.OncePerTarget
	else --"SET"
		EventTableEntry.OncePerTarget = value
	end
end


function SpeakinSpell:CurrentMessagesGUI_ShowSpeechBox(i)
	-- [X] Show Speeches
--	if not SpeakinSpell.RuntimeData.OptionsGUIStates.MessageSettings.ShowSpeechesGroup then
--		return false
--	end
	
	-- must have an EventTableEntry to continue
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	if not EventTableEntry then
		return false
	end
	
	-- [X] Show Read-Only Speeches
	if not SpeakinSpellSavedDataForAll.ShowReadOnlySpeeches then
		local msg = EventTableEntry.Messages[i]
		if msg and (msg ~= "") then
			if EventTableEntry.ReadOnly[msg] then
				return false
			end
		end
	end
	
	-- determine how many Spell Message N input boxes are shown
	-- typically we'll show at least 1 speech message input box if we have a spell selected
	-- we want to show 1 more than the number of speeches currently configured
	-- unless we don't have a spell selected or we're in EnterNewSpell mode
	local NumSpellMessageInputsShown = 1 + #(EventTableEntry.Messages)
	return (i <= NumSpellMessageInputsShown)
end


function SpeakinSpell:CurrentMessagesGUI_ShowSelectedEventControls()
	local EventTableEntry = self:CurrentMessagesGUI_GetSelectedEventObject()
	return (EventTableEntry ~= nil)
end


function SpeakinSpell:CurrentMessagesGUI_RebuildSpellList()
	local values = self.OptionsGUI.args.CurrentMessagesGUI.args.SelectGroup.args.EventSelect.values
	local OptionsGUIState = self.RuntimeData.OptionsGUIStates.MessageSettings
	local EventTable = SpeakinSpellSavedData.EventTable
	
	local MatchesFilterFunc = function(key) 
		local de = SpeakinSpellSavedData.EventTable[key].DetectedEvent
		return SpeakinSpell:MatchesFilter( de, true )
	end
	
	local GetDisplayNameFunc = function(key)
		local de = SpeakinSpellSavedData.EventTable[key].DetectedEvent
		local DisplayNameFormat = {
			typefilter = SpeakinSpell.RuntimeData.OptionsGUIStates.SelectedEventTypeFilter,
			ShowAllRanks = false,
			HighlightFilterText = true,
			BaseColor = "|r",
		}
		return self:FormatDisplayName( de, DisplayNameFormat )
	end
	
	self:RebuildSpellList( values, OptionsGUIState, EventTable, MatchesFilterFunc, GetDisplayNameFunc )
end




function SpeakinSpell:CurrentMessagesGUI_GetSelectedDisplayNameForEditLabel()
	-- include a reminder of the selected event
	local ete = SpeakinSpell:CurrentMessagesGUI_GetSelectedEventObject()
	local label = ""
	if ete and ete.DetectedEvent then
		local DisplayNameFormat = {
			ShowAllRanks = true,
			HighlightFilterText = true,
			BaseColor = SpeakinSpell.Colors.ON,
		}
		label = SpeakinSpell:FormatDisplayName( ete.DetectedEvent, DisplayNameFormat ).."|r"
	end
	return label
end
